// Code generated by smithy-go-codegen DO NOT EDIT.

package drs

import (
	"context"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Export the Source Network CloudFormation template to an S3 bucket.
func (c *Client) ExportSourceNetworkCfnTemplate(ctx context.Context, params *ExportSourceNetworkCfnTemplateInput, optFns ...func(*Options)) (*ExportSourceNetworkCfnTemplateOutput, error) {
	if params == nil {
		params = &ExportSourceNetworkCfnTemplateInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ExportSourceNetworkCfnTemplate", params, optFns, c.addOperationExportSourceNetworkCfnTemplateMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ExportSourceNetworkCfnTemplateOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ExportSourceNetworkCfnTemplateInput struct {

	// The Source Network ID to export its CloudFormation template to an S3 bucket.
	//
	// This member is required.
	SourceNetworkID *string

	noSmithyDocumentSerde
}

type ExportSourceNetworkCfnTemplateOutput struct {

	// S3 bucket URL where the Source Network CloudFormation template was exported to.
	S3DestinationUrl *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationExportSourceNetworkCfnTemplateMiddlewares(stack *middleware.Stack, options Options) (err error) {
	err = stack.Serialize.Add(&awsRestjson1_serializeOpExportSourceNetworkCfnTemplate{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpExportSourceNetworkCfnTemplate{}, middleware.After)
	if err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = addHTTPSignerV4Middleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addOpExportSourceNetworkCfnTemplateValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opExportSourceNetworkCfnTemplate(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opExportSourceNetworkCfnTemplate(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		SigningName:   "drs",
		OperationName: "ExportSourceNetworkCfnTemplate",
	}
}
