// Code generated by smithy-go-codegen DO NOT EDIT.

// Package gamelift provides the API client, operations, and parameter types for
// Amazon GameLift.
//
// Amazon GameLift provides solutions for hosting session-based multiplayer game
// servers in the cloud, including tools for deploying, operating, and scaling game
// servers. Built on Amazon Web Services global computing infrastructure, GameLift
// helps you deliver high-performance, high-reliability, low-cost game servers
// while dynamically scaling your resource usage to meet player demand. About
// Amazon GameLift solutions Get more information on these Amazon GameLift
// solutions in the Amazon GameLift Developer Guide (https://docs.aws.amazon.com/gamelift/latest/developerguide/)
// .
//   - Amazon GameLift managed hosting -- Amazon GameLift offers a fully managed
//     service to set up and maintain computing machines for hosting, manage game
//     session and player session life cycle, and handle security, storage, and
//     performance tracking. You can use automatic scaling tools to balance player
//     demand and hosting costs, configure your game session management to minimize
//     player latency, and add FlexMatch for matchmaking.
//   - Managed hosting with Realtime Servers -- With Amazon GameLift Realtime
//     Servers, you can quickly configure and set up ready-to-go game servers for your
//     game. Realtime Servers provides a game server framework with core Amazon
//     GameLift infrastructure already built in. Then use the full range of Amazon
//     GameLift managed hosting features, including FlexMatch, for your game.
//   - Amazon GameLift FleetIQ -- Use Amazon GameLift FleetIQ as a standalone
//     service while hosting your games using EC2 instances and Auto Scaling groups.
//     Amazon GameLift FleetIQ provides optimizations for game hosting, including
//     boosting the viability of low-cost Spot Instances gaming. For a complete
//     solution, pair the Amazon GameLift FleetIQ and FlexMatch standalone services.
//   - Amazon GameLift FlexMatch -- Add matchmaking to your game hosting solution.
//     FlexMatch is a customizable matchmaking service for multiplayer games. Use
//     FlexMatch as integrated with Amazon GameLift managed hosting or incorporate
//     FlexMatch as a standalone service into your own hosting solution.
//
// About this API Reference This reference guide describes the low-level service
// API for Amazon GameLift. With each topic in this guide, you can find links to
// language-specific SDK guides and the Amazon Web Services CLI reference. Useful
// links:
//   - Amazon GameLift API operations listed by tasks (https://docs.aws.amazon.com/gamelift/latest/developerguide/reference-awssdk.html)
//   - Amazon GameLift tools and resources (https://docs.aws.amazon.com/gamelift/latest/developerguide/gamelift-components.html)
package gamelift
