// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	smithydocument "github.com/aws/smithy-go/document"
)

// A structure that contains information about one link attached to this
// monitoring account sink.
type ListAttachedLinksItem struct {

	// The label that was assigned to this link at creation, with the variables
	// resolved to their actual values.
	Label *string

	// The ARN of the link.
	LinkArn *string

	// The resource types supported by this link.
	ResourceTypes []string

	noSmithyDocumentSerde
}

// A structure that contains information about one of this source account's links
// to a monitoring account.
type ListLinksItem struct {

	// The ARN of the link.
	Arn *string

	// The random ID string that Amazon Web Services generated as part of the link ARN.
	Id *string

	// The label that was assigned to this link at creation, with the variables
	// resolved to their actual values.
	Label *string

	// The resource types supported by this link.
	ResourceTypes []string

	// The ARN of the sink that this link is attached to.
	SinkArn *string

	noSmithyDocumentSerde
}

// A structure that contains information about one of this monitoring account's
// sinks.
type ListSinksItem struct {

	// The ARN of the sink.
	Arn *string

	// The random ID string that Amazon Web Services generated as part of the sink ARN.
	Id *string

	// The name of the sink.
	Name *string

	noSmithyDocumentSerde
}

type noSmithyDocumentSerde = smithydocument.NoSerde
