// Code generated by smithy-go-codegen DO NOT EDIT.

package ssmcontacts

import (
	"context"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
	"time"
)

// Retrieves information about an override to an on-call rotation.
func (c *Client) GetRotationOverride(ctx context.Context, params *GetRotationOverrideInput, optFns ...func(*Options)) (*GetRotationOverrideOutput, error) {
	if params == nil {
		params = &GetRotationOverrideInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "GetRotationOverride", params, optFns, c.addOperationGetRotationOverrideMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*GetRotationOverrideOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type GetRotationOverrideInput struct {

	// The Amazon Resource Name (ARN) of the overridden rotation to retrieve
	// information about.
	//
	// This member is required.
	RotationId *string

	// The Amazon Resource Name (ARN) of the on-call rotation override to retrieve
	// information about.
	//
	// This member is required.
	RotationOverrideId *string

	noSmithyDocumentSerde
}

type GetRotationOverrideOutput struct {

	// The date and time when the override was created.
	CreateTime *time.Time

	// The date and time when the override ends.
	EndTime *time.Time

	// The Amazon Resource Names (ARNs) of the contacts assigned to the override of
	// the on-call rotation.
	NewContactIds []string

	// The Amazon Resource Name (ARN) of the on-call rotation that was overridden.
	RotationArn *string

	// The Amazon Resource Name (ARN) of the override to an on-call rotation.
	RotationOverrideId *string

	// The date and time when the override goes into effect.
	StartTime *time.Time

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationGetRotationOverrideMiddlewares(stack *middleware.Stack, options Options) (err error) {
	err = stack.Serialize.Add(&awsAwsjson11_serializeOpGetRotationOverride{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson11_deserializeOpGetRotationOverride{}, middleware.After)
	if err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = addHTTPSignerV4Middleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addOpGetRotationOverrideValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opGetRotationOverride(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opGetRotationOverride(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		SigningName:   "ssm-contacts",
		OperationName: "GetRotationOverride",
	}
}
