// Code generated by smithy-go-codegen DO NOT EDIT.

package workspacesweb

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/service/workspacesweb/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Retrieves a list of IP access settings.
func (c *Client) ListIpAccessSettings(ctx context.Context, params *ListIpAccessSettingsInput, optFns ...func(*Options)) (*ListIpAccessSettingsOutput, error) {
	if params == nil {
		params = &ListIpAccessSettingsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListIpAccessSettings", params, optFns, c.addOperationListIpAccessSettingsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListIpAccessSettingsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListIpAccessSettingsInput struct {

	// The maximum number of results to be included in the next page.
	MaxResults *int32

	// The pagination token used to retrieve the next page of results for this
	// operation.
	NextToken *string

	noSmithyDocumentSerde
}

type ListIpAccessSettingsOutput struct {

	// The IP access settings.
	IpAccessSettings []types.IpAccessSettingsSummary

	// The pagination token used to retrieve the next page of results for this
	// operation.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListIpAccessSettingsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListIpAccessSettings{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListIpAccessSettings{}, middleware.After)
	if err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = addHTTPSignerV4Middleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListIpAccessSettings(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	return nil
}

// ListIpAccessSettingsAPIClient is a client that implements the
// ListIpAccessSettings operation.
type ListIpAccessSettingsAPIClient interface {
	ListIpAccessSettings(context.Context, *ListIpAccessSettingsInput, ...func(*Options)) (*ListIpAccessSettingsOutput, error)
}

var _ ListIpAccessSettingsAPIClient = (*Client)(nil)

// ListIpAccessSettingsPaginatorOptions is the paginator options for
// ListIpAccessSettings
type ListIpAccessSettingsPaginatorOptions struct {
	// The maximum number of results to be included in the next page.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListIpAccessSettingsPaginator is a paginator for ListIpAccessSettings
type ListIpAccessSettingsPaginator struct {
	options   ListIpAccessSettingsPaginatorOptions
	client    ListIpAccessSettingsAPIClient
	params    *ListIpAccessSettingsInput
	nextToken *string
	firstPage bool
}

// NewListIpAccessSettingsPaginator returns a new ListIpAccessSettingsPaginator
func NewListIpAccessSettingsPaginator(client ListIpAccessSettingsAPIClient, params *ListIpAccessSettingsInput, optFns ...func(*ListIpAccessSettingsPaginatorOptions)) *ListIpAccessSettingsPaginator {
	if params == nil {
		params = &ListIpAccessSettingsInput{}
	}

	options := ListIpAccessSettingsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListIpAccessSettingsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListIpAccessSettingsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListIpAccessSettings page.
func (p *ListIpAccessSettingsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListIpAccessSettingsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	result, err := p.client.ListIpAccessSettings(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

func newServiceMetadataMiddleware_opListIpAccessSettings(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		SigningName:   "workspaces-web",
		OperationName: "ListIpAccessSettings",
	}
}
